/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomHTMLOptionsCollection_H__
#define __GdomHTMLOptionsCollection_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomHTMLCollection.h"
#include "gdom/GdomNode.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomHTMLOptionsCollection GdomHTMLOptionsCollection;
typedef struct _GdomHTMLOptionsCollectionClass GdomHTMLOptionsCollectionClass;


#define GDOM_TYPE_HTML_OPTIONS_COLLECTION            (gdom_html_options_collection_get_type())
#define GDOM_HTML_OPTIONS_COLLECTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_HTML_OPTIONS_COLLECTION, GdomHTMLOptionsCollection))
#define GDOM_HTML_OPTIONS_COLLECTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_HTML_OPTIONS_COLLECTION, GdomHTMLOptionsCollection)Class)
#define GDOM_IS_HTML_OPTIONS_COLLECTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_HTML_OPTIONS_COLLECTION))
#define GDOM_IS_HTML_OPTIONS_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_HTML_OPTIONS_COLLECTION))
#define GDOM_HTML_OPTIONS_COLLECTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_HTML_OPTIONS_COLLECTION, GdomHTMLOptionsCollectionClass))

typedef struct _GdomHTMLOptionsCollectionPrivate GdomHTMLOptionsCollectionPrivate;

struct _GdomHTMLOptionsCollection {
    GdomHTMLCollection parent_instance;
    GdomHTMLOptionsCollectionPrivate *priv;
};

struct _GdomHTMLOptionsCollectionClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_html_options_collection_get_type (void);


/* XXX TODO: custom function gdom_html_options_collection_add */


/* XXX TODO: custom function gdom_html_options_collection_remove */

WEBKIT_API GdomNode *
gdom_html_options_collection_item (GdomHTMLOptionsCollection *thiz, gulong index);

WEBKIT_API GdomNode *
gdom_html_options_collection_named_item (GdomHTMLOptionsCollection *thiz, gchar * name);

G_END_DECLS

#endif /* __GdomHTMLOptionsCollection_H__ */
